function [ image_out ] = apply_hefe( image_in )
% Applies the Instagram filter 'Hefe' to an image
%   Expects and returns a 640x640x3 double array in the range [0, 1]

tonemap_coeff = ...
    [-13.47 41.23 -45.04 19.17 -1.492 0.5954 0.0; ...
    -12.28 41.09 -50.52 26.03 -3.916 0.58 0.0; ...
    -1.066 9.679 -19.09 12.92 -1.835 0.3487 0.0];

vignette = double(imread('vignette.png'))/255;

result = image_in .* vignette;
for channel = 1:3
    result(:,:,channel) = polyval(tonemap_coeff(channel, :), result(:,:,channel));
end
image_out = result;
end

