function [ image_out ] = reverse_hefe( image_in )
% Inverses the Instagram filter 'Hefe' on an image
%   Expects and returns a 640x640x3 double array in the range [0, 1]

inverse_tonemap_coeff = ...
    [-3.835 12.81 -17.35 13.18 -5.738 1.939 0.0; ...
    -8.176 28.36 -39.21 28.23 -11.04 2.845 0.0; ...
    -27.59 85.64 -103.7 62.86 -20.07 3.905 0.0];

vignette = double(imread('vignette.png'))/255;

result = zeros(size(image_in));
for channel = 1:3
    result(:,:,channel) = polyval(inverse_tonemap_coeff(channel, :), image_in(:,:,channel));
end

image_out = result ./ vignette;

end

